/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-hrpsys-ros-bridge-1.2.4-0precise-20140912-0408/msg/OpenHRP_AutoBalancerService_GaitGeneratorParam.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_AutoBalancerService_GaitGeneratorParam_
{
  typedef OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> Type;

  OpenHRP_AutoBalancerService_GaitGeneratorParam_()
    : default_step_time(0.0)
    , default_step_height(0.0)
    , default_double_support_ratio(0.0)
    , stride_parameter()
    , default_orbit_type(0)  {
      stride_parameter.assign(0.0);
  }
  OpenHRP_AutoBalancerService_GaitGeneratorParam_(const ContainerAllocator& _alloc)
    : default_step_time(0.0)
    , default_step_height(0.0)
    , default_double_support_ratio(0.0)
    , stride_parameter()
    , default_orbit_type(0)  {
      stride_parameter.assign(0.0);
  }



   typedef double _default_step_time_type;
  _default_step_time_type default_step_time;

   typedef double _default_step_height_type;
  _default_step_height_type default_step_height;

   typedef double _default_double_support_ratio_type;
  _default_double_support_ratio_type default_double_support_ratio;

   typedef boost::array<double, 3>  _stride_parameter_type;
  _stride_parameter_type stride_parameter;

   typedef int64_t _default_orbit_type_type;
  _default_orbit_type_type default_orbit_type;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_AutoBalancerService_GaitGeneratorParam_

typedef ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<std::allocator<void> > OpenHRP_AutoBalancerService_GaitGeneratorParam;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam > OpenHRP_AutoBalancerService_GaitGeneratorParamPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam const> OpenHRP_AutoBalancerService_GaitGeneratorParamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-groovy-hrpsys-ros-bridge-1.2.4-0precise-20140912-0408/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "762f8b103379ef6227eae532dfefe71a";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x762f8b103379ef62ULL;
  static const uint64_t static_value2 = 0x27eae532dfefe71aULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_AutoBalancerService_GaitGeneratorParam";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 default_step_time\n\
float64 default_step_height\n\
float64 default_double_support_ratio\n\
float64[3] stride_parameter\n\
int64 default_orbit_type\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.default_step_time);
      stream.next(m.default_step_height);
      stream.next(m.default_double_support_ratio);
      stream.next(m.stride_parameter);
      stream.next(m.default_orbit_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_AutoBalancerService_GaitGeneratorParam_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>& v)
  {
    s << indent << "default_step_time: ";
    Printer<double>::stream(s, indent + "  ", v.default_step_time);
    s << indent << "default_step_height: ";
    Printer<double>::stream(s, indent + "  ", v.default_step_height);
    s << indent << "default_double_support_ratio: ";
    Printer<double>::stream(s, indent + "  ", v.default_double_support_ratio);
    s << indent << "stride_parameter[]" << std::endl;
    for (size_t i = 0; i < v.stride_parameter.size(); ++i)
    {
      s << indent << "  stride_parameter[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.stride_parameter[i]);
    }
    s << indent << "default_orbit_type: ";
    Printer<int64_t>::stream(s, indent + "  ", v.default_orbit_type);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H
